# サンプルコードについて

これは、WEB+DB PRESS Vol.92の連載「進め！ フロントエンド先遣隊」第3回「WebRTCの現在と未来」のサンプルコードです。
紙面で紹介しているサンプルコードは紙幅の関係で簡略化しているため、実際に収録しているものとは差異がある場合があります。

## サーバの起動

サンプルコードの実行には、Node.jsおよびnpmが必要です。
コマンドラインにて以下のコマンドを実行し、サーバを起動します。
Node.jsおよびnpmの実行パスは各自の環境に合わせて修正してください。

```
$ npm install
$ node index.js
```

## サンプルアプリケーションの実行

ブラウザのウィンドウまたはタブ（以下、まとめて「ウィンドウ」と呼びます）を2つ開き、両方で同じサンプルアプリケーションにアクセスします。
このとき別々のブラウザを使用する必要はなく、同じブラウザの別ウィンドウで構いません。

アプリケーションの性質上、Webカメラおよびマイクが利用可能な状態である必要があります。

各URLの「localhost」の部分を、サーバを起動しているコンピュータのIPアドレスに変更すれば、同一LAN内の別のコンピュータからもアクセスできます。
（ただしChromeはセキュリティ上の理由により不可）

「Your ID: 」の→に表示されている文字列をもう一方のウィンドウの入力欄に入力し、「call」ボタンを押すと相手とのビデオ通話を開始します。
「bye」ボタンを押すと通話を終了します。

## サンプルアプリケーション

このサンプルコードは、紙面の構成に合わせた3つのアプリケーションで構成されています。

### 1. 従来のWebRTC

http://localhost:8000/webrtc/

#### 動作環境

* Firefox 48
* Chrome 53

#### 対応するコード

* リスト1 セッション情報の交換
* リスト2 通信経路候補の交換
* リスト3 メディアの送受信
* リスト4 SDP (※console.logにて表示)

### 2. ORTC

http://localhost:8000/ortc/

#### 動作環境

* Microsoft Edge (Windows 10)

※Edgeでは1つのWebカメラ・マイクを複数のウィンドウで共有できないため、2台のコンピュータを利用する必要があります。

#### 対応するコード

* リスト5 Capabilitiesオブジェクト (※console.logにて表示)
* リスト6 ORTCでメディアを送受信する

### 3. WebRTC 1.0

http://localhost:8000/webrtc/

#### 対応するコード

* リスト7 セッション情報の交換(Promise版)
* リスト8 メディアの送受信(Track版)

#### 動作環境

* Firefox 48

## ライセンス

本サンプル中のソースコードは、すべてApacheライセンス2.0とします。
なお、 common/util.js は、Microsoft社がApacheライセンス2.0で公開しているサンプルコードから一部を抜粋したものです。