// Expressを利用し、8000ポートでサーバを起動
var express = require('express');
var http = require('http');

var app = express();
var server = http.Server(app).listen(8000, '0.0.0.0');
app.use(express.static(__dirname + '/htdocs/'));

var io = require('socket.io')(server);
var webrtcNS = io.of('/');

webrtcNS.on('connection', (socket) => {
	//他ユーザへのシグナリングメッセージ送信
	let events = ['offer', 'answer', 'icecandidate', 'localparams', 'capabilities', 'ringoff'];
	events.forEach((event) => {
		socket.on(event, (userId, payload) => {
			console.log(event);
			webrtcNS.to('/#'+userId).emit(event, socket.id.slice(2), payload);
		});
	});
});